#include<bits/stdc++.h>
using namespace std;

int n, m, k;
int grid[1005][1005];
bool visited[1005][1005];
pair<int, int> pos[10001], s[10001];

bool cmp(pair<int, int> a, pair<int, int> b) {
    if(a.first != b.first) return a.first > b.first;
    return a.second > b.second;
}

void bfs(int sx, int sy, int S, int j) {
    vector<pair<int, int>> v;
    v.push_back({sx, sy});
    int i = 0;

    while(i < v.size()) {
        int x = v[i].first, y = v[i].second;
        visited[x][y] = true;
        i++;
        if(x-1 > 0 && visited[x-1][y] == false && S >= grid[x-1][y]) {
            v.push_back({x-1, y});
        }
        if(y-1 > 0 && visited[x][y-1] == false && S >= grid[x][y-1]) {
            v.push_back({x, y-1});
        }
        if(x+1 <= n && visited[x+1][y] == false && S >= grid[x+1][y]) {
            v.push_back({x+1, y});
        }
        if(y+1 <= m && visited[x][y+1] == false && S >= grid[x][y+1]) {
            v.push_back({x, y+1});
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin>>n>>m>>k;

    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            cin>>grid[i][j];
        }
    }
    grid[2][3] = 0;

    for(int i = 0; i < k; i++) {
        cin>>pos[i].first>>pos[i].second>>s[i].first;
        s[i].second = i;
    }

    sort(s, s+n, cmp);

    int D = 0;
    for(D = 0; true; D++) {
        bfs(pos[s[0].second].first, pos[s[0].second].second, s[0].first + D, s[0].second);
        int cur = 0;
        for(int i = 0; i < k; i++) {
            if(visited[pos[i].first][pos[i].second]) cur++;
        }
        if(cur == k) break;

        for(int i = 1; i <= n; i++) {
            for(int j = 1; j <= m; j++) {
                visited[i][j] = false;
            }
        }
    }

    cout<<D<<endl;

    return 0;
}

