#include<bits/stdc++.h>
using namespace std;
long long n, m, k;
long long edges[1005][1005], x[1005], y[1005], S[1005];
bool used[1005][1005];
void clear_(){
    for(long long i=0;i<1005;i++){
        for(long long j=0;j<1005;j++){
            used[i][j]=false;
        }
    }
}
void bfs(long long x, long long y, long long s){
    queue<pair<long long, long long>> q;
    pair<long long, long long> buff;
    buff.first=x;
    buff.second=y;
    q.push(buff);
    used[x][y]=true;
    while(!q.empty()){
        long long x1=q.front().first;
        long long y1=q.front().second;
        q.pop();

        if(x1-1!=0 && edges[x1-1][y1]<=s && !used[x1-1][y1]){
            buff.first=x1-1;
            buff.second=y1;
            q.push(buff);
            used[x1-1][y1]=true;
        }
        if(x1+1<=n && edges[x1+1][y1]<=s && !used[x1+1][y1]){
            buff.first=x1+1;
            buff.second=y1;
            q.push(buff);
            used[x1+1][y1]=true;
        }
        if(y1-1!=0 && edges[x1][y1-1]<=s && !used[x1][y1-1]){
            buff.first=x1;
            buff.second=y1-1;
            q.push(buff);
            used[x1][y1-1]=true;
        }
        if(y1+1<=m && edges[x1][y1+1]<=s && !used[x1][y1+1]){
            buff.first=x1;
            buff.second=y1+1;
            q.push(buff);
            used[x1][y1+1]=true;
        }
    }
}
bool good(){
    for(long long i=1;i<=n;i++) if(!used[i][1]) return false;
    for(long long i=1;i<=n;i++) if(!used[i][m]) return false;
    for(long long i=1;i<=m;i++) if(!used[1][i]) return false;
    for(long long i=1;i<=m;i++) if(!used[n][i]) return false;
    return true;
}
bool ok(long long d){
    for(long long i=1;i<=k;i++){
        bfs(x[i], y[i], S[i]+d);
        for(long long j=1;j<=k;j++){
            if(i==j) continue;
            if(used[x[j]][y[j]]){
                if(S[i]>S[j]){
                    x[j]=0;
                    y[j]=0;
                }else{
                    x[i]=0;
                    y[i]=0;
                }
            }
        }
        clear_();
    }
    for(long long i=1;i<=k;i++){
        if(x[i]==0 && y[i]==0) continue;
        bfs(x[i], y[i], S[i]+d);
        if(!good()) return false;
        clear_();
    }
    return true;
}
long long dvoichno(long long l, long long r){
    long long mid;
    while(r>l){
        mid=(l+r)/2;
        if(ok(mid)) r=mid-1;
        else l=mid+1;
    }
    return l;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    clear_();
    cin>>n>>m>>k;
    long long max_=0;
    for(long long i=1;i<=n;i++){
        for(long long j=1;j<=m;j++){
            cin>>edges[i][j];
            max_=max(max_, edges[i][j]);
        }
    }
    for(long long i=1;i<=k;i++){
        cin>>x[i]>>y[i]>>S[i];
    }
    cout<<dvoichno(0, max_)<<endl;
    return 0;
}
