#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN_P = 6*1e4 + 50;
const int MAXS = MAXN_P*2;
const int INF = INT_MAX-10;

int br[MAXS+50];
void MEMSET(int* a, int value, int SIZE)
{
    for (int i = 0; i < SIZE; i++)
        a[i] = value;
}

void solve(int* parent, int k, int& currBr)
{
    if (parent[k] == -1)
    {
        br[k]--;
        if (br[k] == 0)currBr--;
        br[k]++;

        return;
    }

    br[parent[k]]--;


    currBr = currBr-(br[parent[k]]==0?1:0);
    solve(parent, k-parent[k], currBr);
    br[parent[k]]++;
}

vector <int> answer;
void fillAnswer(int *parent, int index)
{
    while (parent[index] != -1)
    {
        answer.push_back(parent[index]);
        index = index-parent[index];
    }
    answer.push_back(index);
}

int parent[MAXS+50];
int a[MAXN_P], dp[MAXS+50];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, p;

    MEMSET(dp, INF, MAXS+30);
    set <int> nominal;

    //memset(parent, -1, sizeof(parent));

    cin >> n >> p;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        parent[a[i]] = -1;
        br[a[i]]++;
        nominal.insert(a[i]);
    }

    int total = nominal.size();

    parent[0] = -1;
    dp[0] = 0;
    for (int i = 0; i < n; i++)
    {
        for (int currSum = 2*p+50; currSum >= a[i]; currSum--)
        {

            if ((parent[currSum] > -1) && (dp[currSum-a[i]]+1 < dp[currSum]))
                parent[currSum] = a[i];

            dp[currSum] = min(dp[currSum-a[i]]+1, dp[currSum]);
        }


        dp[a[i]] = 1;
    }


    int MAX = -1000, MAXINDEX = -1;
    for (int i = p; i <= 2*p; i++)
    {
        int k = total;

        if (dp[i] != INF)
        {
            solve(parent, i, k);
            if (k > MAX)
            {
                MAX = k;
                MAXINDEX = i;
            }
        }

    }

    cout << MAX << " " << MAXINDEX << endl;

    fillAnswer(parent, MAXINDEX);
    sort (answer.begin(), answer.end());

    int sz = answer.size();
    cout << answer[0];
    for (int i = 1; i < sz; i++)
        cout << " " << answer[i];

    cout << endl;

    return 0;
}
