#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 1e3 + 10, MAXK = 1e6+10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m, k;
int a[MAXN][MAXN];
struct person
{
    int x, y, s;
    person() {};
    person(int _x, int _y, int _s)
    {
        x = _x;
        y = _y;
        s = _s;
    }
};
person p[MAXK];
void read()
{
    cin >> n >> m >> k;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> a[i][j];
        }
    }
    for (int i = 1; i <= k; ++ i)
    {
        cin >> p[i].x >> p[i].y >> p[i].s;
    }
}
struct cell
{
    int x, y;
    cell() {};
    cell(int _x, int _y)
    {
        x = _x;
        y = _y;
    }
    cell operator+(cell c2)
    {
        cell ans = cell(x + c2.x, y + c2.y);
        return ans;
    }
    bool in_range()
    {
        return(x >= 1 && x <= n && y >= 1 && y <= m);
    }
};
cell dir[4] = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};
bool used[MAXN][MAXN];
int mi[MAXN][MAXN];
int bravery;
void dfs(cell beg)
{
    used[beg.x][beg.y] = 1;
    if(beg.x == 1 || beg.x == n || beg.y == 1 || beg.y == m)
    {
        mi[beg.x][beg.y] = a[beg.x][beg.y];
    }
    cell nb;
    for (int i = 0; i < 4; ++ i)
    {
        nb = beg + dir[i];
        if(nb.in_range())
        {
            if(!used[nb.x][nb.y])
            {
                dfs(nb);

                    mi[beg.x][beg.y] = max(a[nb.x][nb.y], mi[nb.x][nb.y]);

            }
        }
    }
}
bool solve()
{
    memset(mi, 0, sizeof(mi));

    for (int i = 1; i <= m; ++ i)
    {
        memset(used, 0, sizeof(used));
        dfs(cell(1, i));
        memset(used, 0, sizeof(used));
        dfs(cell(n, i));
    }
    for (int i = 1; i <= n; ++ i)
    {
        memset(used, 0, sizeof(used));
        dfs(cell(i, 1));
         memset(used, 0, sizeof(used));
        dfs(cell(i, m));
    }
int ans = 0;
    for (int i = 1; i <= k; ++ i)
    {

            ans = max(ans, mi[p[i].x][p[i].y]);
    }
    cout << ans-p[1].s << endl;
}

int main()
{
    speed();
    read();
 solve();
    return 0;
}
/***
3 3 3
2 2 1
5 2 2
1 1 3
2 2 1
3 1 1
3 2 1
*/
