#include<bits/stdc++.h>

using namespace std;
struct edge
{
    int x,y;
    edge(){}
    edge(int _x, int _y)
    {
        x=_x;
        y=_y;
    }
    edge operator + (edge e)
    {
        edge ans;
        ans.x=x+e.x;
        ans.y=y+e.y;
        return ans;
    }
};
edge dir[4]={{1,0},{0,1},{-1,0},{0,-1}};
int n,m,k;
long long a[501][501];
int x[250001],y[250001];
long long s[250001];
int i,j;
void read()
{
    cin>>n>>m>>k;
    for(i=1;i<=n;i++)
    {
        for(j=1;j<=m;j++)
        {
            cin>>a[i][j];
        }
    }
    for(i=0;i<k;i++)
        cin>>x[i]>>y[i]>>s[i];
}
bool found;
long long maximum;
bool used[1024][1024];
void DFS(edge i)
{
    if(found)return;
    used[i.x][i.y]=1;
    //cout<<a[i.x][i.y]<<"-"<<i.x<<" "<<i.y<<endl;
    for(j=0;j<4;j++)
    {
        edge nb=i+dir[j];
        if(nb.x>n||nb.x<1||nb.y>m||nb.y<1)
        {
            //cout<<"here"<<endl;
            found=1;
        }
        else if(!used[nb.x][nb.y]&&a[nb.x][nb.y]<=maximum&&!found)DFS(nb);
    }
}
int mid;
bool check()
{
    for(i=0;i<k;i++)
    {
        maximum=mid+s[i];
        //cout<<i<<" "<<maximum<<endl;
        edge e(x[i],y[i]);
        DFS(e);
        memset(used,0,sizeof(used));
        if(!found)return 0;
        found=0;
    }
    return 1;
}
int ans=201;
void solve()
{
    int l=0,r=201;
    while(l<=r)
    {
        mid=(l+r)/2;
        //cout<<"NEW"<<mid<<endl;
        if(check())
        {
            //cout<<"here"<<" "<<mid<<endl;
            if(mid<ans)ans=mid;
            r=mid-1;
        }
        else l=mid+1;
    }
    cout<<ans<<endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
/*
5 10 5
5 5 5 5 7 2 2 2 2 2
5 1 1 1 7 1 1 1 1 2
5 1 6 6 7 4 5 5 5 5
5 1 6 1 7 1 5 1 1 2
5 5 6 5 7 5 5 2 2 2
4 6 1
2 9 1
4 9 1
4 4 1
2 3 1

*/
