#include<iostream>
#include<vector>
#include<queue>
#include<tuple>
#include<cstring>
#include<algorithm>
//#include<bits/stdc++.h>
using namespace std;
const int MAX_N=1e3+3;
const int MAX_K=1e6+4;
int tab[MAX_N][MAX_N];
int n,m,k;
vector<pair<pair<int,int>,int> >a;
int d1[]={0,1,-1,0};
int d2[]={1,0,0,-1};

int used[MAX_N][MAX_N];
int parent[MAX_K];
int sz[MAX_K];
bool okman[MAX_K];
bool okparent[MAX_K];
void Init()
{
    memset(used,0,sizeof(used));
    memset(okman,0,sizeof(okman));
    memset(okparent,0,sizeof(okparent));
    for(int i=1;i<=k;i++)
    {
        sz[i]=1;
        parent[i]=i;
    }
}
void Read()
{
    cin>>n>>m>>k;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin>>tab[i][j];
        }
    }
    a.push_back({{-1,-1},-1});
    int x,y,z;
    for(int i=1;i<=k;i++)
    {
        cin>>x>>y>>z;
        a.push_back({{z,x},y});
    }
    sort(a.begin(),a.end());
}
int Find(int u)
{
    if(parent[u]==u)return u;
    else return parent[u]=Find(parent[u]);
}
void Merge(int u,int v)
{
    int urt=Find(u);
    int vrt=Find(v);
    if(sz[urt]>sz[vrt])swap(urt,vrt);
    sz[vrt]+=sz[urt];
    parent[urt]=vrt;
}
void ForMan(int x,int y,int s,int i)
{
    queue<pair<int,int> >q;
    q.push({x,y});
    if(used[x][y])
    {
        Merge(i,used[x][y]);
        //dsu i->used[x][y];
        return;
    }
    //used[x][y]=i;
    while(!q.empty())
    {
        int cur_x;
        int cur_y;
        tie(cur_x,cur_y)=q.front();
        q.pop();
        if(cur_x==1 or cur_x==n or cur_y==1 or cur_y==m)
        {
            okman[i]=1;
        }
        for(int idx=0;idx<4;idx++)
        {
            int n_x=cur_x+d1[idx];
            int n_y=cur_y+d2[idx];
            if(n_x<1 or n_y<1 or n_x>n or n_y>m)continue;
            if(tab[n_x][n_y]>s)continue;
            if(!used[n_x][n_y])
            {
                used[n_x][n_y]=i;
                q.push({n_x,n_y});
            }
            else if(used[n_x][n_y]!=i)
            {
                Merge(i,used[n_x][n_y]);
                //dsu i->used[n_x][n_y];
            }
        }
    }
}
bool Check(int d)
{
    Init();
    for(int i=k;i>=1;i--)
    {
        int x,y,z;
        z=a[i].first.first;
        x=a[i].first.second;
        y=a[i].second;
        ForMan(x,y,z+d,i);
    }
    for(int i=1;i<=k;i++)
    {
        int root=Find(i);
        okparent[root]=max(okparent[root],okman[i]);
    }
    for(int i=1;i<=k;i++)
    {
        int root=Find(i);
        if(!okparent[root])return false;
    }
    return true;
}
void Search()
{
    int l=0,r=2e9;
    int ans;
    while(l<=r)
    {
        int mid=(l+r)/2;
        if(Check(mid))
        {
            ans=mid;
            r=mid-1;
        }
        else l=mid+1;
    }
    cout<<ans<<endl;
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    Read();
    Search();
    //cout<<Check(1)<<endl;



    return 0;
}

