#include <iostream>
#include <utility>
#include <queue>
#include <algorithm>
using namespace std;

int n,m;
pair<long long, pair<int,int>> sxy[1000000];
long long table[1000][1000],k, minplus[1000][1000];
bool tableima[1000][1000],hooked[1000][1000];
void dfs(int x, int y, long long seg, long long plusa){
    if(hooked[x][y]) return;
    hooked[x][y]=true;
    if(tableima[x][y]){
        if(minplus[x][y]==-1 || plusa+seg-table[x][y]<minplus[x][y]){
            minplus[x][y]=plusa+seg-table[x][y];
        }
    }
    if(x+1<=n){
        long long pl=table[x+1][y]-seg-plusa;
        if(pl<0) pl=0;
        dfs(x+1,y,seg,plusa+pl);
    }
    if(y+1<=m){
        long long pl=table[x][y+1]-seg-plusa;
        if(pl<0) pl=0;
        dfs(x,y+1,seg,plusa+pl);
    }
    if(x-1>=0){
        long long pl=table[x-1][y]-seg-plusa;
        if(pl<0) pl=0;
        dfs(x-1,y,seg,plusa+pl);
    }
    if(y-1>=0){
        long long pl=table[x][y-1]-seg-plusa;
        if(pl<0) pl=0;
        dfs(x,y-1,seg,plusa+pl);
    }
    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>> n >> m >> k;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cin>> table[i][j];
        }
    }

    for(long long i=0;i<k;i++){
        cin>> sxy[i].second.first >> sxy[i].second.second >> sxy[i].first;
        tableima[sxy[i].second.first][sxy[i].second.second]=true;
        minplus[sxy[i].second.first][sxy[i].second.second]=-1;
    }
    sort(sxy,sxy+k);
    long long otg=0;
    for(long long i=k-1;i>=0;i--){
        dfs(sxy[i].second.first,sxy[i].second.second,sxy[i].first,0);
        if(minplus[sxy[i].second.first][sxy[i].second.second]>otg) otg=minplus[sxy[i].second.first][sxy[i].second.second];
    }
    cout<< otg;




    return 0;
}