#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

struct People
{
    int x, y, fear;
    People(){}
    People(int x, int y, int fear)
        :x(x), y(y), fear(fear){}


};

bool cmp(const People& a, const People& b)
{
    if (a.fear != b.fear)return a.fear < b.fear;
    return a.x < b.x;
}

const int MAXN = 1005;

People people[MAXN*MAXN];
int a[MAXN][MAXN], n, m, k;
bool visited[MAXN][MAXN];

bool canPass(int x, int y, int fear)
{
    if (visited[x][y] == true) return false;
    if (a[x][y] > fear) return false;
    if (x == 0 || y == 0 || x == n-1 || y == m-1) return true;


    visited[x][y] = true;
    bool ans = canPass(x+1, y, fear) || canPass(x, y+1, fear) || canPass(x-1, y, fear) || canPass(x, y-1, fear);
    visited[x][y] = false;

    return ans;
}

bool check(int mid)
{
    for (int i = 0; i < k; i++)
    {
        if (canPass(people[i].x, people[i].y, people[i].fear + mid) == false)
        {
            return false;
        }

        //cout << people[i].x << " " << people[i].y << " " << people[i].fear + mid << endl;
    }




    return true;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> k;

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
        {
            cin >> a[i][j];
        }

    for (int i = 0; i < k; i++)
    {
        int x, y, s;
        cin >> x >> y >> s;

        people[i] = People(x-1, y-1, s);
    }

    int left = 0, right = 1e9;

    while (left+1 < right)
    {
        int mid = (left+right)/2;
        bool ans = check(mid);

        if (ans == false)left = mid+1;
        else right = mid;


    }

    if (check(left) == true)cout << left << endl;
    else cout << right << endl;


    return 0;
}
/*
3 4 3
7 8 2 3
8 6 8 4
100 100 100 5
2 2 6
2 4 6
3 4 6
*/
