#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 1e3 + 10, MAXK = 1e6+10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m, k;
int a[MAXN][MAXN];
struct person
{
    int x, y, s;
    person() {};
    person(int _x, int _y, int _s)
    {
        x = _x;
        y = _y;
        s = _s;
    }
};
person p[MAXK];
void read()
{
    cin >> n >> m >> k;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> a[i][j];
        }
    }
    for (int i = 1; i <= k; ++ i)
    {
        cin >> p[i].x >> p[i].y >> p[i].s;
    }
}
struct cell
{
    int x, y;
    cell() {};
    cell(int _x, int _y)
    {
        x = _x;
        y = _y;
    }
    cell operator+(cell c2)
    {
        cell ans = cell(x + c2.x, y + c2.y);
        return ans;
    }
    bool in_range()
    {
        return(x >= 1 && x <= n && y >= 1 && y <= m);
    }
};
cell dir[4] = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};
int used[MAXN][MAXN];
int mi[MAXN][MAXN];
long long bravery;
bool dfs(cell beg)
{
    used[beg.x][beg.y] = 1;
    if(beg.x == 1 || beg.x == n || beg.y == 1 || beg.y == m)
    {
        mi[beg.x][beg.y] = 1;
        return 1;
    }
    cell nb;
    for (int i = 0; i < 4; ++ i)
    {
        nb = beg + dir[i];
        if(nb.in_range())
        {
            if(a[nb.x][nb.y] <= bravery && mi[nb.x][nb.y] == 1)
            {
                mi[beg.x][beg.y] = 1;
                return true;
            }
            else if(!used[nb.x][nb.y]&& a[nb.x][nb.y] <= bravery)
            {
                if(dfs(nb) == 1)
                {
                    mi[beg.x][beg.y] = 1;
                    return true;
                }
            }
        }
    }

    return false;
}
bool check(int x)
{
    memset(used, 0, sizeof(used));
    memset(mi, 0, sizeof(mi));
    for (int i = 1; i <= k; ++ i)
    {
        memset(used, 0, sizeof(used));
        bravery = p[i].s + x;
        if(!dfs(cell(p[i].x, p[i].y)))
            return false;
    }
    return true;
}
void bin_search()
{
    long long left = 0, right = 1e9, mid, ans = 1e9;
    while(left <= right)
    {
        mid = (left + right)/2;
        if(check(mid))
        {
            right = mid - 1;
            ans = min(ans, mid);
        }
        else
            left = mid + 1;
    }
    cout << ans << endl;
}
int main()
{
    speed();
    read();
    bin_search();
    return 0;
}
