#include<bits/stdc++.h>

using namespace std;
struct edge
{
    int x,y;
    edge() {}
    edge(int _x, int _y)
    {
        x=_x;
        y=_y;
    }
    edge operator + (edge e)
    {
        edge ans;
        ans.x=x+e.x;
        ans.y=y+e.y;
        return ans;
    }
};
edge dir[4]= {{1,0},{0,1},{-1,0},{0,-1}};
int n,m,k;
long long a[1024][1024];
int x[250001],y[250001];
long long s[250001];
bool used[1024][1024];
long long maxneed;
void read()
{
    cin>>n>>m>>k;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin>>a[i][j];
        }
    }
    for(int i=0; i<k; i++)
    {
        cin>>x[i]>>y[i]>>s[i];
        used[x[i]][y[i]]=1;
        if(s[i]>maxneed)maxneed=s[i];
    }
}
bool found;
long long maximum;
bool used1[1024][1024];
void DFS(edge i)
{
    used1[i.x][i.y]=1;
    for(int j=0; j<4; j++)
    {
        edge nb=i+dir[j];
        if(nb.x>n||nb.x<1||nb.y>m||nb.y<1)
        {
            found=1;
        }
        else if(!used1[nb.x][nb.y]&&a[nb.x][nb.y]<=maximum)
            DFS(nb);
    }
}
long long mid;
bool check()
{
    for(int i=0; i<k; i++)
    {
        maximum=mid+s[i];
        edge e(x[i],y[i]);
        if(!used1[x[i]][y[i]])
            DFS(e);
        else
            found=1;
        if(!found)
        {
            memset(used1,0,sizeof(used1));
            return 0;
        }
        found=0;
    }
    memset(used1,0,sizeof(used1));
    return 1;
}
long long ans=1000000000;
void solve()
{
    long long l=0,r=1000000000;
    while(l<=r)
    {
        mid=(l+r)/2;
        //cout<<"NEW"<<mid<<endl;
        if(check())
        {
            //cout<<"here"<<" "<<mid<<endl;
            if(mid<ans)
                ans=mid;
            r=mid-1;
        }
        else
            l=mid+1;
    }
    cout<<ans<<endl;
}
void subtask1()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(!used[i][j])
            {
                if(a[i][j]<maxneed)
                {
                    cout<<0<<endl;
                }
                else cout<<a[i][j]-maxneed<<endl;
                return;
            }
        }
    }
}
bool subtaskcheck()
{
    int fixed=-1;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(!used[i][j])
            {
                if(fixed==-1)
                {
                    fixed=a[i][j];
                }
                else if(a[i][j]!=fixed)
                {
                    return 0;
                }
            }
        }
    }
    return 1;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    if(subtaskcheck())subtask1();
    else solve();
    return 0;
}
/*
5 10 5
5 5 5 5 7 2 2 2 2 2
5 1 1 1 7 1 1 1 1 2
5 1 6 6 7 4 5 5 5 5
5 1 6 1 7 1 5 1 1 2
5 5 6 5 7 5 5 2 2 2
4 6 1
2 9 1
4 9 1
4 4 1
2 3 1

*/
